  ### NOTE: To push a dashboard to grafana:
###    pipenv run python3 generate_grafana_dashboard.py --env test --template http_response --datasource watcher

import argparse
import colorama
from pprint import pformat, pprint
import json
import requests
from os import getenv
import os
from grafanalib.core import Dashboard
from grafanalib._gen import DashboardEncoder, load_dashboard


def get_dashboard_json(dashboard, overwrite=False, message="Updated by grafanlib"):
    '''
    get_dashboard_json generates JSON from grafanalib Dashboard object

    :param dashboard - Dashboard() created via grafanalib
    '''

    # grafanalib generates json which need to pack to "dashboard" root element
    return json.dumps(
        {
            "dashboard": dashboard.to_json_data(),
            "overwrite": overwrite,
            "message": message
        }, sort_keys=True, indent=2, cls=DashboardEncoder)


def upload_to_grafana(json, server, api_key, verify=True):
    '''
    upload_to_grafana tries to upload dashboard to grafana and prints response

    :param json - dashboard json generated by grafanalib
    :param server - grafana server name
    :param api_key - grafana api key with read and write privileges
    '''

    headers = {'Authorization': f"Bearer {api_key}", 'Content-Type': 'application/json'}
    r = requests.post(f"http://{server}/api/dashboards/db", data=json, headers=headers, verify=verify)
    # TODO: add error handling
    #print(f"{r.status_code} - {r.content}")

    return r.json()


grafana_api_key = getenv("GRAFANA_API_KEY")
grafana_server = getenv("GRAFANA_SERVER")

parser = argparse.ArgumentParser(description="Create Page Hierarchy")
parser.add_argument('--template', help="Grafana template name (ex: pfsense)")
args = parser.parse_args()

print("#"*50)
print("Generating Dashboard from {}".format(args.template))
print("#"*50)
my_dashboard = load_dashboard(os.path.join('templates', args.template))

print("#"*50)
print("Pushing Dashboard to Grafana")
print("#"*50)
my_dashboard_json = get_dashboard_json(my_dashboard, overwrite=True)

# print("grafana_server = {}".format(grafana_server))
# print("grafana_api_key = {}".format(grafana_api_key))
grafana_server="grafana.h8n.lan:3000"
result = upload_to_grafana(my_dashboard_json, grafana_server, grafana_api_key)
#pprint(result)
print("#" * 50)
print(colorama.Fore.GREEN)
templatename = args.template + ".dashboard"
print("SUMMARY\n----------")
print("dashboard_url: {dashboard_url}\ngrafana_url: {grafana_instance}\ndashboard: {dashboard}\n".format(
    dashboard_url="http://" + grafana_server + result['url'],
    dashboard=templatename,
    grafana_instance=grafana_server
))
print(colorama.Style.RESET_ALL)
